C**********************************************************************
C**********************************************************************
C** 
C**     File: jitax_kcd.for
C**
C**     Project: jitax_kcd
C**
C**     Description: Test program for kcd.for
C**
C**********************************************************************
C**
C** Copyright (c) 2003 Scott A. Belmonte
C**
C** This file is part of jitax_kcd. Reproduction, in whole or in part,
C** is only permitted under licence. For licensing information see
C** licence.txt at the top of the jitax_kcd source tree.
C**
C** E-mail: scott.belmonte@ntlworld.com
C**
C**********************************************************************
C**********************************************************************
C
      PROGRAM JITAX_KCD
      IMPLICIT NONE
C     
      INCLUDE 'kcd.inc'
C
C     Functions
C
      INTEGER OPEN_KCD_FILE
      INTEGER READ_KCD_DATA
      INTEGER STRLEN
C
C     Variables
C
      INTEGER    MAXIMSIZE
      PARAMETER (MAXIMSIZE=625*576)
      INTEGER KCD_ERROR
      INTEGER I                 ! Loop counter
      INTEGER FRAME1(MAXIMSIZE) ! Frame 1 data array
      INTEGER FRAME2(MAXIMSIZE) ! Frame 2 data array
      INTEGER DATA(MAXIMSIZE)   ! Minimum frame array
C     
      KCD_ERROR = OPEN_KCD_FILE('i01f0005.kcd')
      IF (KCD_ERROR .NE. 0) GOTO 901
      WRITE(*,*) ID
      WRITE(*,*) DETID, GONID
      WRITE(*,*) DATETIME
      WRITE(*,*) SLOT, REPEATS, READOUTS
      WRITE(*,*) EXPTIME, INTTIME
      WRITE(*,*) WIDTH, HEIGHT
      WRITE(*,*) THETA, PHI, PHIRANGE, PHIINTERVAL
      WRITE(*,*) OMEGA, KAPPA, DXSTART
      WRITE(*,*) HVVOLT, MACURRENT
      WRITE(*,*) XSIZE, YSIZE
      WRITE(*,*) TARGET
      WRITE(*,*) ALPHA1, ALPHA2, ALPHRATIO
      WRITE(*,*) POLARISATION
      WRITE(*,*) KAPPAANG, SCINTYPE, SCINLOAD
      WRITE(*,*) SHUTTER
      WRITE(*,*) DETGAIN, BEAMDIA, BEAMDIST
      WRITE(*,*) DATTYPE
      WRITE(*,*) BITSPERSAMPLE
C
C     Error checking
C
      IF (MAXIMSIZE .LT. (WIDTH*HEIGHT)) GOTO 903
C
      KCD_ERROR = READ_KCD_DATA(1, FRAME1)
      IF (KCD_ERROR .NE. 0) GOTO 902
      KCD_ERROR = READ_KCD_DATA(2, FRAME2)
      IF (KCD_ERROR .NE. 0) GOTO 902
      CALL CLOSE_KCD_FILE()
C
C     Create auto-correlation frame
C
      DO I = 1, (WIDTH*HEIGHT)
         IF (FRAME1(I) .LT. FRAME2(I)) THEN
            DATA(I) = FRAME1(I)
         ELSE
            DATA(I) = FRAME2(I)
         ENDIF
      ENDDO
C
C      DO I = 1, (WIDTH*HEIGHT)
C         WRITE(*,*) I, FRAME1(I), FRAME2(I), DATA(I)
C      ENDDO
      WRITE(*,*) FRAME1(1), FRAME2(1), DATA(1)
      WRITE(*,*) FRAME1(2), FRAME2(2), DATA(2)
      WRITE(*,*) FRAME1(1000), FRAME2(1000), DATA(1000)
      WRITE(*,*) FRAME1(WIDTH*HEIGHT-2), 
     $           FRAME2(WIDTH*HEIGHT-2), 
     $           DATA(WIDTH*HEIGHT-2)
      WRITE(*,*) FRAME1(WIDTH*HEIGHT-1), 
     $           FRAME2(WIDTH*HEIGHT-1), 
     $           DATA(WIDTH*HEIGHT-1)
      WRITE(*,*) FRAME1(WIDTH*HEIGHT), 
     $           FRAME2(WIDTH*HEIGHT), 
     $           DATA(WIDTH*HEIGHT)
      RETURN
C
C     Error traps
C
 901  WRITE(*,*) '** Error opening kcd file'
      RETURN
 902  WRITE(*,*) '** Error reading data: ', KCD_ERROR
      RETURN
 903  WRITE(*,*) '** Error data arrays not large enough'
      WRITE(*,*) '** MAXIMSIZE = ', MAXIMSIZE
      WRITE(*,*) '** (WIDTH*HEIGHT) = ', (WIDTH*HEIGHT)
      RETURN
      END
C
